//
//  AppDelegate.m
//  ScreenCaptureTest
//
//  Created by zjs on 2018/3/31.
//  Copyright © 2018年 ggniu.cn. All rights reserved.
//

#import "AppDelegate.h"

@interface AppDelegate ()

@property (weak) IBOutlet NSWindow *window;
@end

@implementation AppDelegate

NSTextField* textSizeShow;
- (void)onOK
{
    char szpath[1024] = {0};
    uint32_t size = sizeof(szpath);
    _NSGetExecutablePath(szpath, &size);
    
    char* tmp = strrchr(szpath, '/');
    //tmp++;
    *tmp = '\0';
    tmp = strrchr(szpath, '/');
    tmp++;
    *tmp = '\0';
    NSString * strPath = [NSString stringWithUTF8String:szpath];
    strPath = [strPath stringByAppendingString:@"Resources/"];
    NSLog(@"%@", strPath);
    
    
    NSString* homePath = [[[NSProcessInfo processInfo]environment]objectForKey:@"HOME"];
    
    NSString* strConfigPath = [strPath stringByAppendingPathComponent:@"config.info"];
    NSString* strResponsePath = [homePath stringByAppendingPathComponent:@"response.info"];
    NSLog(@"configpath:%@", strConfigPath);
    NSLog(@"responsepath:%@", strResponsePath);
   
    NSFileManager *fm = [NSFileManager defaultManager];
    [fm removeItemAtPath:strResponsePath error:NULL];
    
    NSString* cmdArgs = [NSString stringWithFormat:@"startfromlocal,%@,%@,authcode,0,3,0,0,0,0", strConfigPath, strResponsePath];
    NSLog(@"cmdArgs: %@", cmdArgs);
    NSArray * args = [[NSArray alloc] initWithObjects:cmdArgs, nil]; // 初始化参数列表， 可增加
    
	
	//请将ScreenCapture.app复制到您的APP可执行程序目录下，或其他可由您的程序调用起来的目录  （测试放到桌面上是调用不起来的）
    NSString* TempPath = [strPath stringByAppendingString:@"NiuniuCapture.app/Contents/MacOS/NiuniuCapture"];
    
    NSTask *task = [[NSTask alloc] init];
    
    [task setLaunchPath:TempPath];
    
    [task setArguments:args];
    NSLog(@"start capture:%@", TempPath);
    [task launch];
    
    [task waitUntilExit];
    
	//read response
    NSError* err1=nil; 
	NSString* request=[NSString stringWithContentsOfFile:strResponsePath encoding:NSUTF8StringEncoding error:&err1];
	if(err1 != nil)
	{
		//request = @"{}";
	}
	
	NSError *err;  
	NSMutableDictionary *resultDic = [NSJSONSerialization JSONObjectWithData:[request dataUsingEncoding:NSUTF8StringEncoding] options:NSJSONReadingMutableContainers error:&err]; 
	if(resultDic == nil)
	{
		[textSizeShow setStringValue:@"截图失败"];
		return;
	}
	
	int x = 0;
	int	y = 0;
	int width = 0;
	int height = 0;
	int type = -1;
	
	if ([resultDic objectForKey:@"x"])	
		x = [[resultDic objectForKey:@"x"] intValue];
	
	if ([resultDic objectForKey:@"y"])	
		y = [[resultDic objectForKey:@"y"] intValue];
	
	if ([resultDic objectForKey:@"Width"])	
		width= [[resultDic objectForKey:@"Width"] intValue];
	
	if ([resultDic objectForKey:@"Height"])	
		height = [[resultDic objectForKey:@"Height"] intValue];
	
	if ([resultDic objectForKey:@"Type"])	
		type = [[resultDic objectForKey:@"Type"] intValue];
	
	switch(type)
	{
		case 1:
		[textSizeShow setStringValue:[NSString stringWithFormat:@"截图成功：(%d, %d, %d, %d)", x, y, width, height]];
		break;
		case 2:
		[textSizeShow setStringValue:@"您取消了截图"];
		break;
		case 3:
		[textSizeShow setStringValue:[NSString stringWithFormat:@"您保存了截图：(%d, %d, %d, %d)", x, y, width, height]];
		break;
		default:
		[textSizeShow setStringValue:@"未知截图结果"];
		break;
	}
    
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification {
    // Insert code here to initialize your application
    NSView* myView = self.window.contentView;
   
    NSButton * okButton = [[NSButton alloc] initWithFrame:NSMakeRect(200, 200, 120, 50)];
    [okButton setTitle:@"开始截图"];
    [okButton setTarget:self];
    [okButton setAction:@selector(onOK)];
    [myView addSubview:okButton];
    
	
	textSizeShow = [[NSTextField alloc] initWithFrame:NSMakeRect(50, 100, 400, 20)];
    [textSizeShow setBezeled:NO];
    [textSizeShow setDrawsBackground:NO];
    [textSizeShow setEditable:NO];
    [textSizeShow setSelectable:NO];
	[textSizeShow setStringValue:@""];
	[myView addSubview:textSizeShow];
}


- (void)applicationWillTerminate:(NSNotification *)aNotification {
    // Insert code here to tear down your application
}


@end
